#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include "LIST-LIB.H"

using namespace std;

// funzione distruttore
lista::~lista()
{
   nodo *p;
   while(l!=0)
   {
      p=l;
      l=l->succ;
      delete p;
      cout << '#';
   }
   cout << endl;
}


// ----------- Funzioni di inserimento elemento in lista --------------------------

void lista::push(int x)
{
    l=insert(l,x);
}

/* inserisce gli elementi in modo disordinato (inserimento in testa)     */
 

nodo* lista::insert(nodo *p,int x)
{
  nodo *q;
 
  cout << "insert: versione con inserimento in testa"<<endl;
  q=new nodo;        // Alloca una elemento; il suo indirizzo e' q
  q->valore=x;
  q->succ=p;
  p=q;
  return p;
}

       
// --------------------------------------------------------------------------------

/* cancella un elemento dalla lista - restituisce true se l'elemento e' stato trovato */ 
                                        
bool lista::cancella(int x)
{
  nodo *lc, *lp;
  bool trovato=false;

  lc=l;
  lp=0;

  while( (lc!=0) && !trovato)
  {
      if(lc->valore == x)
          trovato=true;
      else
      {
          lp=lc;
	  lc=lc->succ;
      }
  }
  if (trovato)
  {
     if (lp==0)
	    l=l->succ;
	 else
	     lp->succ=lc->succ;
	 delete lc;
	 return true;
  }
  else
	 return false;
}


/* stampa a video gli elementi di una lista */
void lista::stampa()
{
  nodo *lc;
  
  lc=l;
  while(lc!=0)
  {
	 printf("elemento= %d\n",lc->valore);
     lc=lc->succ;
  }
}


/* verifica se un elemento e' presenta nella lista - restituisce true in caso affermativo */
/* N.B. non si fanno ipotesi sull'ordinamento della lista                                 */

bool lista::trova(int x)
{
   return find(l,x);
}

bool lista::find(nodo *lc, int elem)    /* RICORSIVA */
{
  if(lc==0)
	 return false;
  else if(lc->valore == elem)
	return true;
  else
	return find(lc->succ, elem);
}


/*  --------- ordinamento della lista con il metodo MERGE-SORT ------------- */

void lista::ordina()
{
   l=MergeSort(l);
}

nodo* lista::split(nodo *l1)
{
  nodo * l2;
  if( (l1==0)||(l1->succ==0) )
    return 0;
  l2=l1->succ;
  l1->succ=l2->succ;
  l2->succ=split(l1->succ);
  return l2;
}

nodo* lista::Merge(nodo *l1, nodo *l2)
{
  if(l1==0)
    return l2;
  if(l2==0)
    return l1;
  if(l1->valore <= l2->valore)
  {
     l1->succ=Merge(l1->succ, l2);
     return l1;
  }
  else
  {
     l2->succ=Merge(l1, l2->succ);
     return l2;
  }
}

nodo* lista::MergeSort(nodo *l1)
{
  nodo *l2;
  if( (l1==0)||(l1->succ==0) )
     return l1;
  else
  {
    l2=split(l1);
    l1=MergeSort(l1);
    l2=MergeSort(l2);
    return Merge(l1,l2);
  }
}
// --------------------------------------------------------------------------------


